package ru.dbotthepony.mc.otm.storage;

import java.util.HashMap;
import java.util.Objects;

public class StorageObjectRegistry {
	private static final HashMap<Class<? extends IStorageObject>, StorageObjectTuple<? extends IStorageObject>> REGISTRY = new HashMap<>();

	public static <T extends IStorageObject> boolean register(Class<T> identity, T empty) {
		final var tuple = new StorageObjectTuple<>(identity, empty);
		final boolean removed = REGISTRY.remove(identity) != null;
		REGISTRY.put(identity, tuple);

		return removed;
	}

	@SuppressWarnings("unchecked")
	public static <T extends IStorageObject> StorageObjectTuple<T> get(Class<T> identity) {
		return (StorageObjectTuple<T>) REGISTRY.get(identity);
	}

	public static <T extends IStorageObject> StorageObjectTuple<T> getOrError(Class<T> identity) {
		return Objects.requireNonNull(get(identity), "No storage mapping present for " + identity.toString());
	}
}
